'Created by -=Twink=-
'Version 1.14
'Last Updated 06/02/04
'
'ChangeLog
' 1.14
'* 06/02/04 - Added ShowSpeed to Last Uploaded/Download Files (set ShowSpeed to True to turn on)
'
' 1.13
'* 28/08/03 - Allow you to Hide files in Last Downloaded/Uploaded Files
'
' 1.12
'* 23/08/03 - Added Queue Size in MB and Length (number of files queued)
'
' 1.11
'* 19/07/03 - Added Option to not show timestamps
'* 14/07/03 - Changed Number of Items Shown to function parameters instead of global variables
'* 14/07/03 - Fixed a few bugs due to small log files
'
' 1.1
'* 13/07/03 - Added Unique Uploads and Top X Uploads
'* 13/07/03 - Added Ratio
'* 13/07/03 - Added Number Downloads/Uploads/Total Completed
'* 11/07/03 - Added Total Uploaded/Downloaded
'
' 1.0
'* 10/07/03 - Added Basic Show Finished Down/Uploads

' Note I expect ur Logs to be in the following Format
' Downloads: 	%Y-%m-%d %H:%M: %[target] downloaded from %[user], %[size] (%[chunksize]), %[speed], %[time]
' Uploads: 	%Y-%m-%d %H:%M: %[source] uploaded to %[user], %[size] (%[chunksize]), %[speed], %[time]
 
DCPath = "c:\program\DC++\"
DownloadLog 	= DCPath & "Logs\Downloads.log"
UploadLog	= DCPath & "Logs\Uploads.log"
Settings 	= DCPath & "DCPlusPlus.xml"
Queue 		= DCPath & "Queue.xml"
ShowTimeStamps 	= True
ShowSpeed 	= False

'If You dont want ur filelist in your top X Uploads uncomment the next line
UploadsExcluding = "" '"MyList.bz2:MyList.DcLst"

'Set the Extension for Files you dont wish to show here
FinishedDownloadsExcluding = ".bz2:.dclst" ' use this to hide file lists -> ".bz2:.dclst"
FinishedUploadsExcluding   = "" ' use this to hide file lists ->".bz2:.dclst"

'Gets Number Of Files In Queue
Function GetQueueLength()

	filecontents = ReadFile(Queue)
	GetQueueLength = 0
	start = 1

	do while start > 0		
		start =  Instr(1,filecontents,"<Download ")
		if start > 0 then 
			filecontents = Mid(filecontents,start+11)
			GetQueueLength = GetQueueLength + 1
		end if		
	loop		
End Function


'Gets Size of Queue in MB
Function GetQueueSize()
	filecontents = ReadFile(Queue)
	GetQueueSize = 0
	start = 1

	do while start > 0		
		start =  Instr(1,filecontents,"Size=" & chr(34))
		if start > 0 then
			finish = Instr(start+1,filecontents, chr(34))		     
			GetQueueSize=GetQueueSize+ Mid(filecontents,start+6,finish-start+4)
			filecontents = Mid(filecontents,finish)			
		end if
	loop		
	GetQueueSize = (GetQueueSize/1024)/1024
End Function


Function TopUploads(ShowMostUploaded)
dim Files(),Count()
redim Files(0),Count(0)

	Set FSys = CreateObject("Scripting.FileSystemObject")
	Set MyFile = FSys.OpenTextFile(UploadLog, 1)

	do while not MyFile.AtEndOfStream
		File = MyFile.Readline
		start = InStrRev(File,"\",-1,1) + 1
		if start < 17 then start = 19
		length = InStr(File,"uploaded to") - start -1


		File = Mid(File,start,length)
		pos = PositionInArray(Files,File)
		if pos=-1 then
		  if Instr(UploadsExcluding,File)=0 Then
			pos = UBound(Files)+1
			ReDim Preserve Files(pos)
			ReDim Preserve Count(pos)
			Files(pos)=File
			Count(pos)=1
		  end if
		else
			Count(pos) = Count(pos) + 1
		end if
	loop		

	MyFile.close

	TopUploads = ""
	if ShowMostUploaded > UBound(Count) Then ShowMostUploaded = UBound(Count)
	for i = 0 to ShowMostUploaded - 1
		highest = i
	   	for j=i to UBound(Count) -1
			if Count(j)>Count(highest) then
				highest = j
			end if
		next
		tempCount=Count(i)
		Count(i)=Count(highest)
		Count(highest)=tempCount
		tempFile=Files(i)
		Files(i)=Files(highest)
		Files(highest)=tempFile		    
		TopUploads = TopUploads & Count(i) & " - " & Files(i) &  vbNewLine
	next

End Function


Function UniqueUploads
dim Files()
redim Files(0)

	Set FSys = CreateObject("Scripting.FileSystemObject")
	Set MyFile = FSys.OpenTextFile(UploadLog, 1)

	do while not MyFile.AtEndOfStream
		File = MyFile.Readline
		start = InStrRev(File,"\",-1,1) + 1
		if start < 17 then start = 19
		length = InStr(File,"uploaded to") - start -1


		File = Mid(File,start,length)
		pos = PositionInArray(Files,File)
		if pos=-1 then
		  if Instr(UploadsExcluding,File)=0 Then
			pos = UBound(Files)+1
			ReDim Preserve Files(pos)
			ReDim Preserve Count(pos)
			Files(pos)=File
		  end if
		end if
	loop

	MyFile.close

	UniqueUploads = UBound(Files)
End Function


Function Ratio
	Ratio = TotalUploaded / TotalDownloaded
End Function

Function NoTransfersCompleted
	NoTransfersCompleted = NoDownloadsCompleted + NoUploadsCompleted
End Function

Function NoDownloadsCompleted
	NoDownloadsCompleted = LineCount(DownloadLog)
End Function

Function NoUploadsCompleted
	NoUploadsCompleted = LineCount(UploadLog)
End Function


Function ShowFinishedDownloads(ShowDownloads)
	ShowFinishedDownloads = LastLinesExcluding(DownloadLog,ShowDownloads,FinishedDownloadsExcluding,"downloaded from")
End Function

Function ShowFinishedUploads(ShowUploads)
	ShowFinishedUploads = LastLinesExcluding(UploadLog,ShowUploads,FinishedUploadsExcluding,"uploaded to")
End Function

Private Function LastLinesExcluding(FileName,NoLines,Excluding,parse)
	dim file,Lines
	
	contents = ReadFile(FileName)
	MyArray = Split(contents,VbCrLf)
	NoLines = CInt(NoLines)
	
	LastLinesExcluding = ""
	Lines = 0

	i = UBound(MyArray)-1 
	Do While Lines < NoLines and I > 0
		start = InStrRev(MyArray(i),"\",-1,1) + 1
		if start < 17 then start = 19
		length = InStr(MyArray(i),parse) - start -1
		File = ""

		if ShowTimeStamps = True then
			File = File + Mid(MyArray(i),1,16) + " " 
		End If

		File = File +  Mid(MyArray(i),start,length)

		if ShowSpeed = True then
			start = InStr(MyArray(i), "),")
			length = InStr(start+2, MyArray(i), ",") - start - 2
			File = File + Mid(MyArray(i),start+2,length) 
		End If

		
		
		if Instr(lcase(Excluding),lcase(Mid(File,InStrRev(File,"."))))=0 then		
			LastLinesExcluding = File  + vbNewLine + LastLinesExcluding
			Lines = Lines + 1
		End if

		I = I - 1
	Loop
End Function

Function TotalUploaded()
	filecontents = readFile(Settings)
	start = Instr(filecontents,"<TotalUpload type=" & chr(34) & "int64" & chr(34) & ">") + 26
	endat =  Instr(start,filecontents,"</TotalUpload>")

	TotalUploaded = Mid(filecontents,start,endat-start)/1073741824
End Function

Function TotalDownloaded()
	filecontents = readFile(Settings)
	
	start = Instr(filecontents,"<TotalDownload type=" & chr(34) & "int64" & chr(34) & ">") + 28
	endat =  Instr(start,filecontents,"</TotalDownload>")

	TotalDownloaded = Mid(filecontents,start,endat-start)/1073741824
End Function


Private Function LineCount(FilePath)
   Dim objFSO, objTextFilein, sReadLine
   Const ForReading = 1, ForWriting = 2, ForAppending = 8
   Set objFSO = CreateObject("Scripting.FileSystemObject")
   Set objTextFilein = objFSO.OpenTextFile(Filepath, ForReading)
   LineCount = 0
   Do While Not objTextFilein.AtEndOfStream
    sReadLine = objTextFilein.ReadLine
    LineCount = LineCount + 1
   Loop
   Set sReadLine = Nothing
   objTextFilein.Close
End Function

Private Sub writeFile(fileName,contents)
		set fs=CreateObject("Scripting.FileSystemObject")
		set f=fs.CreateTextFile(fileName,true)
		f.write(contents)
		f.close
End Sub

Private Function readFile(fileName)

	dim contents

	Set fs = CreateObject ("Scripting.FileSystemObject")
        If (fs.FileExists(fileName)) Then
		Set filePath = fs.GetFile(fileName)
		set File = filePath.OpenAsTextStream (1, -2)

		contents = file.readall

		File.Close ' Closes the file
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else 
		Exit Function
        End If

	' return file contents
	readFile = contents
End Function

Private Function PositionInArray(aMyArray, strLookingFor)

  strSearchThis = join(aMyArray, VbCrLf)
  find = instr(strSearchThis,strLookingFor)
  if find = 0 then
	PositionInArray = -1
	Exit Function
  end if

  strSearchThis = Mid(strSearchThis,1,find + len(strLookingFor) + 1)
  MyArray = split(strSearchThis,VbCrLf)
  PositionInArray = UBound(MyArray) -1

End Function

